"use strict";var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function asyncGeneratorStep(e,t,n,r,a,i,s){try{var u=e[i](s),o=u.value}catch(e){return void n(e)}u.done?t(o):Promise.resolve(o).then(r,a)}function _asyncToGenerator(u){return function(){var e=this,s=arguments;return new Promise(function(t,n){var r=u.apply(e,s);function a(e){asyncGeneratorStep(r,t,n,a,i,"next",e)}function i(e){asyncGeneratorStep(r,t,n,a,i,"throw",e)}a(void 0)})}}var CONSTANTS=require("./constants"),CLIENT_TYPE="Rsagen",CLIENT_VERSION="Rsagen-V3.0.1.20190615",ALGORITHM_TYPE="Normal",ALGORITHM="NONEWITHRSA",OUTPUT_DATA_NAME="signData",HOST="inner.rnd-signserver.huawei.com",zipUtils=require("./zip-utils"),_require=require("js-base64"),encode=_require.encode,Base64=_require.Base64,http=require("http"),_fs=require("fs"),_crypto=require("crypto"),_signature=require("./signature");function processChunk(e,t){var n=t.startIndex,r=t.startIndex+t.len,n=e.slice(n,r),r=Buffer.alloc(5+t.len);r[0]=CONSTANTS.BEGIN_TAG,r.writeInt32LE(n.length,1),n.copy(r,5),t.sign=getBufferSha256(r)}function hashFile(e){return getBufferSha256(_fs.readFileSync(e))}function getChunkDigest(e){function t(e){e.copy(r,a),a+=e.length}var n=e.sections,e=n.header.sign.length+n.central.sign.length+n.footer.sign.length+5,r=Buffer.alloc(e),a=0;return r.writeInt8(CONSTANTS.JOINT_TAG,0),r.writeInt32LE(3,1),a+=5,t(n.header.sign),t(n.central.sign),t(n.footer.sign),getBufferSha256(r)}function signDigest(e,t){var r={keyId:t.keyId,clientType:CLIENT_TYPE,clientVersion:CLIENT_VERSION,algorithmType:ALGORITHM_TYPE,userName:t.userName,unSignData:encode(e),passwordDigest:t.passwordDigest,algorithm:ALGORITHM,outFileNameArray:[OUTPUT_DATA_NAME],encryptPassword:t.encryptPassword};return new Promise(function(n){var e=http.request({host:t.host||HOST,method:"POST",path:"/sign",headers:{"Content-Type":"application/json"}},function(e){var t="";e.on("data",function(e){t+=e}),e.on("end",function(){n(JSON.parse(t))})});e.on("error",function(e){console.error("problem with request: ".concat(e.message))}),e.write(JSON.stringify(r)),e.end()})}function updateUnsignedData(e){var t=Buffer.from(CONSTANTS.SIGN_HEADER),n=getBufferSha256(e),r=Buffer.alloc(n.length+t.length),e=0;return t.copy(r,0),e+=t.length,n.copy(r,e),r}function getDigestObject(e){var t=Buffer.alloc(e.length+12);return t.writeInt32LE(e.length+8,0),t.writeInt32LE(CONSTANTS.CRYPT_TYPE_RSA_SHA256,4),t.writeInt32LE(e.length,8),e.copy(t,12),{len:t.length,buffer:t}}function getDcObj(e,t){var n={len:12,digests:{size:0,data:[]},certs:{size:0,data:[]},additional:0};return n.digests.data.push(e),n.digests.size+=e.len,n.len+=e.len,n.certs.data.push(t),n.certs.size+=t.len,n.len+=t.len,n}function getSignedObject(e,t){return _getSignedObject.apply(this,arguments)}function _getSignedObject(){return(_getSignedObject=_asyncToGenerator(_regenerator.default.mark(function e(t,n){var r,a,i,s,u;return _regenerator.default.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:if((r={len:16+n.cert.pemBuffer.length,size:12+n.cert.pemBuffer.length,signdata:{size:0,buffer:null},signatures:{size:0,data:[]},pubkey:{size:n.cert.pemBuffer.length,buffer:n.cert.pemBuffer}}).signdata.buffer=makeSignDataBuffer(t),r.signdata.size=t.len,r.size+=t.len,r.len+=t.len,a=void 0,n.signOnline)return i=updateUnsignedData(r.signdata.buffer),e.next=10,signDigest(i,n.onlineConfig);e.next=16;break;case 10:if((s=e.sent).success){e.next=13;break}throw new Error(s.message);case 13:a=Buffer.from(Base64.toUint8Array(s.data.signData)),e.next=19;break;case 16:(u=_crypto.createSign("RSA-SHA256")).update(r.signdata.buffer),a=u.sign(n.privateKey);case 19:return u={len:a.length+12,size:a.length+8,id:CONSTANTS.CRYPT_TYPE_RSA_SHA256,buffer:a},r.signatures.data.push(u),r.signatures.size+=u.len,r.size+=u.len,r.len+=u.len,e.abrupt("return",r);case 25:case"end":return e.stop()}},e)}))).apply(this,arguments)}function constructSignedData(e,t,n){return _constructSignedData.apply(this,arguments)}function _constructSignedData(){return(_constructSignedData=_asyncToGenerator(_regenerator.default.mark(function e(t,n,r){var a,i,s;return _regenerator.default.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:if((i={len:4+n.len,size:n.len,data:[]}).data.push(n),s={len:i.len+12,size:i.len+4,id:CONSTANTS.SIGN_TYPE_FULL_PACKAGE,value:i},(a={len:32+s.len,size:24+s.len,data:[]}).data.push(s),t.files)return e.next=8,signFiles(t.files,r);e.next=10;break;case 8:(i=e.sent)&&((s={len:4+i.length,size:i.length,data:[]}).data.push(i),s={len:s.len+12,size:s.len+4,id:CONSTANTS.SIGN_TYPE_FILE_LIST,value:s},a.data.push(s),a.size+=s.len,a.len+=s.len);case 10:return e.abrupt("return",a);case 11:case"end":return e.stop()}},e)}))).apply(this,arguments)}function makeSignDataBuffer(e){var t=Buffer.alloc(e.len),n=0;return t.writeInt32LE(e.digests.size,n),n+=4,e.digests.data.forEach(function(e){e.buffer.copy(t,n),n+=e.len}),t.writeInt32LE(e.certs.size,n),n+=4,e.certs.data.forEach(function(e){e.buffer.copy(t,n),n+=e.len}),t.writeInt32LE(e.additional,n),t}function saveSignChunk(e){var t=Buffer.alloc(e.len),n=0;return t.writeInt32LE(e.size,n),n+=4,t.writeInt32LE(0,n),n+=4,e.data.forEach(function(e){t.writeInt32LE(e.size,n),n+=4,t.writeInt32LE(0,n),n+=4,t.writeInt32LE(e.id,n),n+=4,t.writeInt32LE(e.value.size,n),n+=4,CONSTANTS.SIGN_TYPE_FULL_PACKAGE===e.id?e.value.data.forEach(function(e){t.writeInt32LE(e.size,n),n+=4,t.writeInt32LE(e.signdata.size,n),n+=4,e.signdata.buffer.copy(t,n),n+=e.signdata.buffer.length,t.writeInt32LE(e.signatures.size,n),n+=4,e.signatures.data.forEach(function(e){t.writeInt32LE(e.size,n),n+=4,t.writeInt32LE(e.id,n),n+=4,t.writeInt32LE(e.buffer.length,n),n+=4,e.buffer.copy(t,n),n+=e.buffer.length}),t.writeInt32LE(e.pubkey.size,n),n+=4,e.pubkey.buffer.copy(t,n),n+=e.pubkey.buffer.length}):CONSTANTS.SIGN_TYPE_FILE_LIST===e.id&&e.value.data.forEach(function(e){e.copy(t,n),n+=e.length})}),t.writeInt32LE(e.size,n),n+=4,t.writeInt32LE(0,n),n+=4,Buffer.from(CONSTANTS.SIGN_MAGIC).copy(t,n),t}function getSignFilesObject(e){var a={len:8,size:4,digests:[],sign:null};return e.forEach(function(e){var t=_signature.CRC32.digest(e.name.toString()),n=6+e.hash.length,r=Buffer.alloc(n);r.writeInt32LE(t,0),r.writeInt16LE(e.hash.length,4),e.hash.copy(r,6),a.digests.push(r),a.size+=n,a.len+=n}),a}function signFiles(e,t){return _signFiles.apply(this,arguments)}function _signFiles(){return(_signFiles=_asyncToGenerator(_regenerator.default.mark(function e(t,n){var r,a,i,s,u,o;return _regenerator.default.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:if(r=getSignFilesObject(t),a=Buffer.alloc(r.size),i=0,r.digests.forEach(function(e){e.copy(a,i),i+=e.length}),n.onlineConfig)return o=updateUnsignedData(a),e.next=8,signDigest(o,n.onlineConfig);e.next=14;break;case 8:if((u=e.sent).success){e.next=11;break}throw new Error(u.message);case 11:s=Buffer.from(Base64.toUint8Array(u.data.signData)),e.next=17;break;case 14:(o=_crypto.createSign("RSA-SHA256")).update(a),s=o.sign(n.privateKey);case 17:return r.digests=a.slice(),r.sign={len:12+s.length,size:8+s.length,id:CONSTANTS.CRYPT_TYPE_RSA_SHA256,data:s},r.len+=r.sign.len,e.abrupt("return",saveDigestChunk(r));case 21:case"end":return e.stop()}},e)}))).apply(this,arguments)}function saveDigestChunk(e){var t=Buffer.alloc(e.len),n=0;return t.writeInt32LE(e.size,0),n+=4,e.digests.copy(t,4),n+=e.digests.length,t.writeInt32LE(e.sign.size,n),t.writeInt32LE(e.sign.id,n+=4),t.writeInt32LE(e.sign.data.length,n+=4),e.sign.data.copy(t,n+=4),t}function signZipResource(e,t,n){return _signZipResource.apply(this,arguments)}function _signZipResource(){return(_signZipResource=_asyncToGenerator(_regenerator.default.mark(function e(t,n,r){var a,i,s;return _regenerator.default.wrap(function(e){for(;;)switch(e.prev=e.next){case 0:if(zipUtils.checkZipBuffer(t)){e.next=2;break}return e.abrupt("return",null);case 2:if((a=zipUtils.parserZip(t)).options={files:n},a.tag){e.next=6;break}return e.abrupt("return",null);case 6:return Object.keys(a.sections).forEach(function(e){e=a.sections[e];processChunk(t,e)}),i=getChunkDigest(a),i=getDigestObject(i),i=getDcObj(i,r.cert.obj),e.next=12,getSignedObject(i,r);case 12:return s=e.sent,e.next=15,constructSignedData(a.options,s,r);case 15:return s=e.sent,a.signchunk=saveSignChunk(s),e.abrupt("return",saveChunks(t,a));case 18:case"end":return e.stop()}},e)}))).apply(this,arguments)}function getBufferSha256(e){var t=_crypto.createHash("SHA256");return t.update(e),t.digest()}function saveChunks(e,t){var n=Buffer.alloc(e.length+t.signchunk.length),r=0,a=t.sections;return e.copy(n,0,a.header.startIndex,a.header.startIndex+a.header.len),r+=a.header.len,t.signchunk.copy(n,r),r+=t.signchunk.length,e.copy(n,r,a.central.startIndex,a.central.startIndex+a.central.len),r+=a.central.len,e.writeInt32LE(a.central.startIndex+t.signchunk.length,a.footer.startIndex+16),e.copy(n,r,a.footer.startIndex,a.footer.startIndex+a.footer.len),n}function getSignChunkData(e,t){var n={};return n.size=e.readInt32LE(t),n.id=e.readInt32LE(t+=8),t+=4,n.value={},n.value.size=e.readInt32LE(t),n.value.data=[],{data:n,index:t+=4}}function getSignaturesData(e,t){var n={};n.size=e.readInt32LE(t),n.id=e.readInt32LE(t+=4);var r=e.readInt32LE(t+=4);return n.buffer=e.slice(t+=4,t+r),{sData:n,index:t+=r}}function getSignChunk(e,t){for(var n=(l=t.previous+8)+t.len,r=[],a={signDataBufList:[]};l<n;){var i=getSignChunkData(e,l),s=i.data,u=(l=i.index)+s.value.size,o={};if(CONSTANTS.SIGN_TYPE_FULL_PACKAGE===s.id)for(;l<u;){o.size=e.readInt32LE(l);var c=getOneBlock(e,l+=4);o.signdata=c.obj,l=c.i,a.signDataBufList.push(o.signdata.buffer),o.signatures={},o.signatures.size=e.readInt32LE(l);var f=(l+=4)+o.signatures.size;for(o.signatures.data=[];l<f;){var g=getSignaturesData(e,l),l=g.index;o.signatures.data.push(g.sData)}c=getOneBlock(e,l);o.pubkey=c.obj,l=c.i,s.value.data.push(o)}else CONSTANTS.SIGN_TYPE_FILE_LIST===s.id&&(o=e.slice(l,l+s.value.size),s.value.data.push(o));r.push(s)}return a.data=r,a.size=t.size,a}function getOneBlock(e,t){var n={};return n.size=e.readInt32LE(t),n.buffer=e.slice(t+=4,t+n.size),{obj:n,i:t+=n.size}}function getCertBuffer(e){if(e){if(e.signDataBufList&&0<e.signDataBufList.length){var t=0;t+=4+e.signDataBufList[0].readInt32LE(0);var n=e.signDataBufList[0].readInt32LE(t+=4),n=e.signDataBufList[0].slice(t+=4,t+n);return CONSTANTS.CERT_HEAD+n.toString("base64")+CONSTANTS.CERT_END}}else console.error("no sign chunk!")}module.exports={hashFile:hashFile,signZipResource:signZipResource,getBufferSha256:getBufferSha256,getSignChunk:getSignChunk,getCertBuffer:getCertBuffer};